diff -uNrd ircd-hybrid-7rc3/README.hoho ircd-hoho-2r15/README.hoho
--- ircd-hybrid-7rc3/README.hoho	Wed Dec 31 19:00:00 1969
+++ ircd-hoho-2r15/README.hoho	Fri Dec 20 15:37:23 2002
@@ -0,0 +1,52 @@
+
+ Hoho ircd 2r15.
+
+ A lame bunch of changes to hybrid ircd 7, that happen to be
+ convienently packed together. Lots of code is stolen, riped
+ off, and swindled from other places, mainly dancer-ircd.
+
+ INSTALL: 
+ ./mkconf
+ ./configure --help
+ ./configure --whatever-options-you-want
+ make
+ make install
+
+ Changes between hybrid and this:
+
+ - Color stripping
+ - Opers can op themselves
+ - Firedrill, useless, but leet looking
+ - Ident is disable-able in the config file
+ - Opers don't look like opers in /who and /whois
+ - +q is finaly working! -- new in 2r5
+
+ Docs for some of the new commands
+ 
+ - /opme #channel
+   Server swoops in and ops you. Other servers will see you part/
+   rejoin, and then the server ops you. This should be used instead
+   of /mode #channel +o yournick, as that could cause trouble.
+
+ - /firedrill #channel
+   In event of extreme emergencey, such as a channel takeover, 
+   firedrill will kick everyone from the channel, join you as op,
+   and then allow everyone else to rejoin. This is extremely disruptive
+   and should only be used if necessary. This is the only way to join
+   a channel if you are banned. It also will clear all channel modes,
+   topic, banlists, everything.
+
+ - /mode #channel +q luser!*@*
+   Silences a user. Works as if the channel was moderated and the user
+   did not have voice. Ops or voice take precedence, and will allow 
+   a user to speak. Currently the message sent to the client is, 
+   "What good is a phone call if you are unable to speak", you might
+   want to change that. Be careful about banning the exact same hostmask
+   that is quited, you might want to -q+b in that case. 
+
+ - /map
+   Same function as /links, but a much more readable output.
+
+ - disable_auth = [yes|no];
+   In the general section of the config file, disable_auth can be used to
+   prevent ident checking on all hosts. By default ident is enabled.
diff -uNrd ircd-hybrid-7rc3/autoconf/configure.in ircd-hoho-2r15/autoconf/configure.in
--- ircd-hybrid-7rc3/autoconf/configure.in	Sun Jul 14 00:10:33 2002
+++ ircd-hoho-2r15/autoconf/configure.in	Fri Dec 20 15:37:24 2002
@@ -992,7 +992,6 @@
  iauth/Makefile                 \
  iauth/source/Makefile          \
  servlink/Makefile              \
- contrib/Makefile               \
  src/Makefile                   \
  adns/Makefile                  \
  include/Makefile               \
diff -uNrd ircd-hybrid-7rc3/build ircd-hoho-2r15/build
--- ircd-hybrid-7rc3/build	Wed Dec 31 19:00:00 1969
+++ ircd-hoho-2r15/build	Fri Dec 20 15:37:24 2002
@@ -0,0 +1,6 @@
+#!/bin/sh
+#
+# This is stupid. Kill this please.
+#
+./configure --prefix=/usr/local/hybrid7 --enable-openssl --enable-small-net --with-nicklen=20 --with-maxclients=100
+make
diff -uNrd ircd-hybrid-7rc3/doc/example.conf ircd-hoho-2r15/doc/example.conf
--- ircd-hybrid-7rc3/doc/example.conf	Thu Jul 11 19:40:14 2002
+++ ircd-hoho-2r15/doc/example.conf	Fri Dec 20 15:37:23 2002
@@ -624,6 +624,10 @@
 	 */
         default_floodcount = 10;
 
+	/* disable_auth: Prevent checking for ident information on connect */
+
+	disable_auth = no;
+
 	/* failed oper notice: send a notice to all opers on the server when 
 	 * someone tries to OPER and uses the wrong password, host or ident.
 	 */
diff -uNrd ircd-hybrid-7rc3/include/channel.h ircd-hoho-2r15/include/channel.h
--- ircd-hybrid-7rc3/include/channel.h	Tue Aug 20 12:41:58 2002
+++ ircd-hoho-2r15/include/channel.h	Fri Dec 20 15:37:23 2002
@@ -92,6 +92,7 @@
   dlink_list      banlist;
   dlink_list      exceptlist;
   dlink_list      invexlist;
+  dlink_list      quietlist;
 
   time_t          first_received_message_time; /* channel flood control */
   int             received_number_of_privmsgs;
diff -uNrd ircd-hybrid-7rc3/include/channel_mode.h ircd-hoho-2r15/include/channel_mode.h
--- ircd-hybrid-7rc3/include/channel_mode.h	Sun Jul 28 15:19:01 2002
+++ ircd-hoho-2r15/include/channel_mode.h	Fri Dec 20 15:37:23 2002
@@ -80,6 +80,7 @@
 #define CHFL_BAN        0x0010 /* ban channel flag */
 #define CHFL_EXCEPTION  0x0020 /* exception to ban channel flag */
 #define CHFL_INVEX      0x0080
+#define CHFL_QUIET		0x0100
 
 /* Channel Visibility macros */
 
@@ -98,8 +99,9 @@
 #define MODE_NOPRIVMSGS 0x0100
 #define MODE_BAN        0x0400
 #define MODE_EXCEPTION  0x0800
-#define MODE_INVEX	0x2000
+#define MODE_INVEX      0x2000
 #define MODE_HIDEOPS    0x4000
+#define MODE_QUIET      0x8000
 
 /*
  * mode flags which take another parameter (With PARAmeterS)
diff -uNrd ircd-hybrid-7rc3/include/irc_string.h ircd-hoho-2r15/include/irc_string.h
--- ircd-hybrid-7rc3/include/irc_string.h	Fri May 24 19:34:07 2002
+++ ircd-hoho-2r15/include/irc_string.h	Fri Dec 20 15:37:23 2002
@@ -89,6 +89,8 @@
 int vsnprintf (char *str, size_t count, const char *fmt, va_list args);
 #endif
 
+extern char*       strip_colour(char*);
+
 /*
  * clean_string - cleanup control and high ascii characters
  * -Dianora
diff -uNrd ircd-hybrid-7rc3/include/numeric.h ircd-hoho-2r15/include/numeric.h
--- ircd-hybrid-7rc3/include/numeric.h	Mon Aug 19 21:32:19 2002
+++ ircd-hoho-2r15/include/numeric.h	Fri Dec 20 15:37:24 2002
@@ -484,6 +484,9 @@
 #define ERR_KNOCKONCHAN      714
 #define ERR_KNOCKDISABLED    714
 
+#define RPL_QUIETLIST        716
+#define RPL_ENDOFQUIETLIST   717
+
 #define ERR_LAST_ERR_MSG     999
 
 #endif /* INCLUDED_numeric_h */
diff -uNrd ircd-hybrid-7rc3/include/patchlevel.h ircd-hoho-2r15/include/patchlevel.h
--- ircd-hybrid-7rc3/include/patchlevel.h	Tue Aug 20 12:41:58 2002
+++ ircd-hoho-2r15/include/patchlevel.h	Fri Dec 20 15:37:24 2002
@@ -19,9 +19,9 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: patchlevel.h,v 7.37 2002/08/20 16:41:58 db Exp $
+ *  $Id: patchlevel.h,v 7.34 2002/07/16 15:36:10 lusky Exp $
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "hybrid-7rc3"
+#define PATCHLEVEL   "hybrid-7rc3-hoho2r15"
 #endif
diff -uNrd ircd-hybrid-7rc3/include/s_conf.h ircd-hoho-2r15/include/s_conf.h
--- ircd-hybrid-7rc3/include/s_conf.h	Tue Aug 20 12:41:58 2002
+++ ircd-hoho-2r15/include/s_conf.h	Fri Dec 20 15:37:24 2002
@@ -229,7 +229,8 @@
   /* 0 == don't use throttle... */
   int           throttle_time;
   int           use_egd;
-  int		ping_cookie;
+  int	    	ping_cookie;
+  int     		disable_auth;
   int           use_help;
 #ifdef HAVE_LIBCRYPTO
   struct EncCapability *default_cipher_preference;
diff -uNrd ircd-hybrid-7rc3/include/s_serv.h ircd-hoho-2r15/include/s_serv.h
--- ircd-hybrid-7rc3/include/s_serv.h	Fri May 24 19:34:08 2002
+++ ircd-hoho-2r15/include/s_serv.h	Fri Dec 20 15:37:24 2002
@@ -74,12 +74,13 @@
 
 #define CAP_TBURST	0x00040000   /* supports TBURST */
 #define CAP_PARA	0x00080000   /* supports invite broadcasting for +p */
+#define CAP_QU		0x00100000
 
 #define CAP_MASK        (CAP_QS  | CAP_EX   | CAP_CHW  | \
                          CAP_IE  | CAP_EOB  | CAP_KLN  | \
                          CAP_GLN | CAP_HOPS | CAP_AOPS | \
                          CAP_UID | CAP_ZIP  | CAP_ENC | \
-                         CAP_KNOCK  | CAP_PARA)
+                         CAP_KNOCK  | CAP_PARA | CAP_QU)
 
 #ifdef HAVE_LIBZ
 #define CAP_ZIP_SUPPORTED       CAP_ZIP
diff -uNrd ircd-hybrid-7rc3/include/supported.h ircd-hoho-2r15/include/supported.h
--- ircd-hybrid-7rc3/include/supported.h	Tue Jul 16 16:26:47 2002
+++ ircd-hoho-2r15/include/supported.h	Fri Dec 20 15:37:24 2002
@@ -55,18 +55,19 @@
 
 #define FEATURES2 "CHANTYPES=%s" \
                   " PREFIX=%s" \
-		  " CHANMODES=%s%s%s%s" \
+          " CHANMODES=%s%s%s%s" \
 		  " NETWORK=%s" \
-		  " CASEMAPPING=%s" \
+          " CASEMAPPING=%s" \
 		  " CALLERID"
 
 #define FEATURES2VALUES ConfigServerHide.disable_local_channels ? "#" : "#&", \
-                        ConfigChannel.use_halfops ? "(ohv)@%+" : "(ov)@+", \
-                        ConfigChannel.use_except ? "e" : "", \
-                        ConfigChannel.use_invex ? "I" : "", \
-                        "b,k,l,imnpst", \
-                        ConfigChannel.use_anonops ? "a" : "", \
-                        ServerInfo.network_name, CASEMAP
+                          ConfigChannel.use_halfops ? "(ohv)@%+" : "(ov)@+", \
+                          ConfigChannel.use_except ? "e" : "", \
+                          ConfigChannel.use_invex ? "I" : "", \
+                          "bq,k,l,imnpst", \
+                          ConfigChannel.use_anonops ? "a" : "", \
+                          ServerInfo.network_name, CASEMAP
+ 
 
 /*
  * - from mirc's versions.txt
diff -uNrd ircd-hybrid-7rc3/mkconf ircd-hoho-2r15/mkconf
--- ircd-hybrid-7rc3/mkconf	Wed Dec 31 19:00:00 1969
+++ ircd-hoho-2r15/mkconf	Fri Dec 20 15:37:23 2002
@@ -0,0 +1,5 @@
+#!/bin/sh
+autoconf autoconf/configure.in >configure
+chmod a+x configure
+autoheader -I autoconf autoconf/configure.in > include/setup.h.in
+rm -f config.cache
diff -uNrd ircd-hybrid-7rc3/modules/core/m_kick.c ircd-hoho-2r15/modules/core/m_kick.c
--- ircd-hybrid-7rc3/modules/core/m_kick.c	Thu Aug 15 11:01:02 2002
+++ ircd-hoho-2r15/modules/core/m_kick.c	Fri Dec 20 15:37:24 2002
@@ -100,6 +100,8 @@
   if (strlen(comment) > (size_t) TOPICLEN)
     comment[TOPICLEN] = '\0';
 
+  strip_colour(comment);
+  
   *buf = '\0';
   name = parv[1];
   while (*name == ',')
@@ -109,6 +111,7 @@
   if (!*name)
     return;
 
+
   chptr = hash_find_channel(name);
   if (!chptr)
     {
@@ -128,7 +131,7 @@
     }
 #endif
 
-  if (!IsServer(source_p) && !is_any_op(chptr, source_p) ) 
+  if (!IsServer(source_p) && !is_any_op(chptr, source_p) && !IsOper(source_p)) 
     { 
       /* was a user, not a server, and user isn't seen as a chanop here */
       
diff -uNrd ircd-hybrid-7rc3/modules/core/m_message.c ircd-hoho-2r15/modules/core/m_message.c
--- ircd-hybrid-7rc3/modules/core/m_message.c	Sat Jul 13 02:56:34 2002
+++ ircd-hoho-2r15/modules/core/m_message.c	Fri Dec 20 15:37:24 2002
@@ -199,6 +199,8 @@
     return;
   }
 
+  strip_colour(parv[2]);
+
   /* Finish the flood grace period... */
   if(MyClient(source_p) && !IsFloodDone(source_p))
     flood_endgrace(source_p);
diff -uNrd ircd-hybrid-7rc3/modules/core/m_nick.c ircd-hoho-2r15/modules/core/m_nick.c
--- ircd-hybrid-7rc3/modules/core/m_nick.c	Fri Jul 26 12:37:11 2002
+++ ircd-hoho-2r15/modules/core/m_nick.c	Fri Dec 20 15:37:24 2002
@@ -137,7 +137,7 @@
   }
 
   /* check if the nick is resv'd */
-  if(find_nick_resv(nick))
+  if(find_nick_resv(nick) && !IsOper(source_p))
   {
     sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
                me.name, BadPtr(parv[0]) ? "*" : parv[0], nick);
diff -uNrd ircd-hybrid-7rc3/modules/core/m_quit.c ircd-hoho-2r15/modules/core/m_quit.c
--- ircd-hybrid-7rc3/modules/core/m_quit.c	Thu Jul 11 21:01:22 2002
+++ ircd-hoho-2r15/modules/core/m_quit.c	Fri Dec 20 15:37:23 2002
@@ -70,6 +70,7 @@
   char *comment = (parc > 1 && parv[1]) ? parv[1] : client_p->name;
   char reason [TOPICLEN + 1];
 
+  strip_colour(comment);
   source_p->flags |= FLAGS_NORMALEX;
   if (strlen(comment) > (size_t) TOPICLEN)
     comment[TOPICLEN] = '\0';
diff -uNrd ircd-hybrid-7rc3/modules/m_firedrill.c ircd-hoho-2r15/modules/m_firedrill.c
--- ircd-hybrid-7rc3/modules/m_firedrill.c	Wed Dec 31 19:00:00 1969
+++ ircd-hoho-2r15/modules/m_firedrill.c	Fri Dec 20 15:37:23 2002
@@ -0,0 +1,370 @@
+/*
+ *   IRC - Internet Relay Chat, contrib/m_clearchan.c
+ *   Copyright (C) 2002 Hybrid Development Team
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_clearchan.c,v 1.30 2002/06/11 01:49:18 androsyn Exp $
+ */
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "whowas.h"
+#include "irc_string.h"
+#include "hash.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "vchannel.h"
+#include "list.h"
+
+
+#define MSG_CLEARCHAN "FIREDRILL"
+
+extern BlockHeap *ban_heap;
+
+static void mo_clearchan(struct Client *client_p, struct Client *source_p,
+                         int parc, char *parv[]);
+
+static void kick_list(struct Client *client_p, struct Client *source_p, struct Channel *chptr,
+                      dlink_list *list,char *chname);
+
+static void remove_our_modes(int type,
+                      struct Channel *chptr, struct Channel *top_chptr,
+                      struct Client *source_p);
+static void remove_a_mode(int hide_or_not,
+                          struct Channel *chptr, struct Channel *top_chptr,
+                          struct Client *source_p, dlink_list *list, char flag);
+static void free_channel_list(dlink_list *list);
+
+static char    *mbuf;
+
+
+struct Message clearchan_msgtab = {
+  MSG_CLEARCHAN, 0, 0, 2, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_not_oper, m_ignore, mo_clearchan}
+};
+
+void
+_modinit(void)
+{
+  mod_add_cmd(&clearchan_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&clearchan_msgtab);
+}
+
+char *_version = "$Revision: 1.30 $";
+
+/*
+** mo_clearchan
+**      parv[0] = sender prefix
+**      parv[1] = channel
+*/
+static void mo_clearchan(struct Client *client_p, struct Client *source_p,
+                        int parc, char *parv[])
+{
+  struct Channel *chptr, *root_chptr;
+  int on_vchan = 0;
+
+  /* admins only */
+  if (!IsOperAdmin(source_p))
+    {
+      sendto_one(source_p, ":%s NOTICE %s :You have no A flag", me.name, parv[0]);
+      return;
+    }
+
+  /* XXX - we might not have CBURSTed this channel if we are a lazylink
+   * yet. */
+  chptr= hash_find_channel(parv[1]);
+  root_chptr = chptr;
+
+#ifdef VCHANS
+  if (chptr && parc > 2 && parv[2][0] == '!')
+    {
+      chptr = find_vchan(chptr, parv[2]);
+      if (root_chptr != chptr)
+        on_vchan++;
+    }
+#endif
+
+  if( chptr == NULL )
+    {
+      sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+		 me.name, parv[0], parv[1]);
+      return;
+    }
+
+  if(IsMember(source_p, chptr))
+    {
+      sendto_one(source_p, ":%s NOTICE %s :*** Please part %s before using CLEARCHAN",
+                 me.name, source_p->name, parv[1]);
+      return;
+    }
+  /*
+  if (!on_vchan)
+    {
+     sendto_wallops_flags(FLAGS_WALLOP, &me, 
+              "CLEARCHAN called for [%s] by %s!%s@%s",
+              parv[1], source_p->name, source_p->username, source_p->host);
+     sendto_server(NULL, source_p, NULL, NOCAPS, NOCAPS, LL_ICLIENT,
+                   ":%s WALLOPS :CLEARCHAN called for [%s] by %s!%s@%s",
+                   me.name, parv[1], source_p->name, source_p->username,
+                   source_p->host);
+     ilog(L_NOTICE, "CLEARCHAN called for [%s] by %s!%s@%s",
+         parv[1], source_p->name, source_p->username, source_p->host);
+    }
+  else
+    {
+     sendto_wallops_flags(FLAGS_WALLOP, &me,
+              "CLEARCHAN called for [%s %s] by %s!%s@%s",
+              parv[1], parv[2], source_p->name, source_p->username,
+              source_p->host);
+     sendto_server(NULL, source_p, NULL, NOCAPS, NOCAPS, LL_ICLIENT,
+                   ":%s WALLOPS :CLEARCHAN called for [%s %s] by %s!%s@%s",
+                   me.name, parv[1], parv[2], source_p->name,
+                   source_p->username, source_p->host);
+     ilog(L_NOTICE, "CLEARCHAN called for [%s %s] by %s!%s@%s",
+         parv[1], parv[2], source_p->name, source_p->username, source_p->host);
+    } */
+
+  /* Kill all the modes we have about the channel.. making everyone a peon */  
+  remove_our_modes(0, chptr, root_chptr, source_p);
+  
+  /* SJOIN the user to give them ops, and lock the channel */
+
+  sendto_server(client_p, source_p, chptr, NOCAPS, NOCAPS,
+                LL_ICLIENT, ":%s SJOIN %lu %s +nts :@%s",
+                me.name, (unsigned long) (chptr->channelts - 1),
+                chptr->chname, source_p->name);
+  sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN %s",
+                       source_p->name,
+                       source_p->username,
+                       source_p->host,
+                       root_chptr->chname);
+  sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +o %s",
+                       me.name, chptr->chname, source_p->name);
+
+  add_user_to_channel(chptr, source_p, CHFL_CHANOP);
+
+  /* Take the TS down by 1, so we don't see the channel taken over
+   * again. */
+  if (chptr->channelts)
+    chptr->channelts--;
+  
+#ifdef VCHANS
+  if (on_vchan)
+    add_vchan_to_client_cache(source_p,root_chptr,chptr);
+#endif
+
+  chptr->mode.mode =
+    MODE_SECRET | MODE_TOPICLIMIT | MODE_NOPRIVMSGS;
+  free_topic(chptr);
+  chptr->mode.key[0] = 0;
+
+  /* Kick the users out and join the oper */
+  kick_list(client_p, source_p, chptr, &chptr->peons, chptr->chname);
+
+}
+
+void kick_list(struct Client *client_p, struct Client *source_p, struct Channel *chptr,
+	       dlink_list *list,char *chname)
+{
+  struct Client *who;
+  dlink_node *m;
+  dlink_node *next_m;
+
+  for (m = list->head; m; m = next_m)
+    {
+      next_m = m->next;
+      who = m->data;
+      sendto_channel_local(ALL_MEMBERS, chptr,
+			   ":%s KICK %s %s :FIRE DRILL",
+			   source_p->name, chname, who->name);
+      sendto_server(NULL, source_p, chptr, NOCAPS, NOCAPS, LL_ICLIENT,
+                    ":%s KICK %s %s :FIRE DRILL", source_p->name,
+                    chname, who->name);
+      remove_user_from_channel(chptr, who);
+    }
+
+  /* Join the user themselves to the channel down here, so they dont see a nicklist 
+   * or people being kicked */
+  sendto_one(source_p, ":%s!%s@%s JOIN %s",
+	     source_p->name,
+	     source_p->username,
+	     source_p->host,
+	     chname);
+
+  channel_member_names(source_p, chptr, chname, 1);
+
+}
+
+
+/*
+ * remove_our_modes
+ *
+ * inputs       - hide from ops or not int flag
+ *              - pointer to channel to remove modes from
+ *              - if vchan basechannel pointer
+ *              - client pointer
+ * output       - NONE
+ * side effects - Go through the local members, remove all their
+ *                chanop modes etc., this side lost the TS.
+ */
+static void remove_our_modes( int hide_or_not,
+                              struct Channel *chptr, struct Channel *top_chptr,
+                              struct Client *source_p)
+{
+  remove_a_mode(hide_or_not, chptr, top_chptr, source_p, &chptr->chanops, 'o');
+#ifdef REQUIRE_OANDV
+  remove_a_mode(hide_or_not, chptr, top_chptr, source_p, &chptr->chanops_voiced, 'o');
+#endif
+#ifdef HALFOPS
+  remove_a_mode(hide_or_not, chptr, top_chptr, source_p, &chptr->halfops, 'h');
+#endif
+  remove_a_mode(hide_or_not, chptr, top_chptr, source_p, &chptr->voiced, 'v');
+#ifdef REQUIRE_OANDV
+  remove_a_mode(hide_or_not, chptr, top_chptr, source_p, &chptr->chanops_voiced, 'v');
+#endif
+
+  /* Move all voice/ops etc. to non opped list */
+  dlinkMoveList(&chptr->chanops, &chptr->peons);
+#ifdef HALFOPS
+  dlinkMoveList(&chptr->halfops, &chptr->peons);
+#endif
+  dlinkMoveList(&chptr->voiced, &chptr->peons);
+#ifdef REQUIRE_OANDV
+  dlinkMoveList(&chptr->chanops_voiced, &chptr->peons);
+#endif
+  dlinkMoveList(&chptr->locchanops, &chptr->locpeons);
+#ifdef HALFOPS
+  dlinkMoveList(&chptr->lochalfops, &chptr->locpeons);
+#endif
+  dlinkMoveList(&chptr->locvoiced, &chptr->locpeons);
+#ifdef REQUIRE_OANDV
+  dlinkMoveList(&chptr->locchanops_voiced, &chptr->locpeons);
+#endif
+
+  /* Clear all +beI modes */
+  free_channel_list(&chptr->banlist);
+  free_channel_list(&chptr->exceptlist);
+  free_channel_list(&chptr->invexlist);
+  chptr->banlist.head = chptr->exceptlist.head = chptr->invexlist.head = NULL;
+  chptr->banlist.tail = chptr->exceptlist.tail = chptr->invexlist.tail = NULL;
+}
+
+
+/*
+ * remove_a_mode
+ *
+ * inputs       -
+ * output       - NONE
+ * side effects - remove ONE mode from a channel
+ */
+static void remove_a_mode( int hide_or_not,
+                           struct Channel *chptr, struct Channel *top_chptr,
+                           struct Client *source_p, dlink_list *list, char flag)
+{
+  dlink_node *ptr;
+  struct Client *target_p;
+  char buf[BUFSIZE];
+  char lmodebuf[MODEBUFLEN];
+  char *lpara[MAXMODEPARAMS];
+  char *chname;
+  int count = 0;
+
+  mbuf = lmodebuf;
+  *mbuf++ = '-';
+
+  lpara[0] = lpara[1] = lpara[2] = lpara[3] = "";
+
+  chname = chptr->chname;
+
+  ircsprintf(buf,":%s MODE %s ", me.name, chname);
+
+  for (ptr = list->head; ptr && ptr->data; ptr = ptr->next)
+    {
+      target_p = ptr->data;
+      lpara[count++] = target_p->name;
+
+      *mbuf++ = flag;
+      if (count >= MAXMODEPARAMS)
+        {
+          *mbuf   = '\0';
+          sendto_channel_local(hide_or_not, chptr,
+                               ":%s MODE %s %s %s %s %s %s",
+                               me.name,
+                               chname,
+                               lmodebuf,
+                               lpara[0], lpara[1], lpara[2], lpara[3] );
+
+          mbuf = lmodebuf;
+          *mbuf++ = '-';
+          count = 0;
+          lpara[0] = lpara[1] = lpara[2] = lpara[3] = "";
+        }
+    }
+
+  if(count != 0)
+    {
+      *mbuf   = '\0';
+      sendto_channel_local(hide_or_not, chptr,
+                           ":%s MODE %s %s %s %s %s %s",
+                           me.name,
+                           chname,
+                           lmodebuf,
+                           lpara[0], lpara[1], lpara[2], lpara[3] );
+
+    }
+}
+
+
+/*
+ * free_channel_list
+ *
+ * inputs       - pointer to dlink_list
+ * output       - NONE
+ * side effects -
+ */
+static void free_channel_list(dlink_list *list)
+{
+  dlink_node *ptr;
+  dlink_node *next_ptr;
+  struct Ban *actualBan;
+
+  for (ptr = list->head; ptr; ptr = next_ptr)
+    {
+      next_ptr = ptr->next;
+
+      actualBan = ptr->data;
+      MyFree(actualBan->banstr);
+      MyFree(actualBan->who);
+      BlockHeapFree(ban_heap, actualBan);
+
+      free_dlink_node(ptr);
+    }
+}
+
